Ant Trip HDU - 3018(欧拉路的个数 + 并查集)

题意:

  Ant Tony和他的朋友们想游览蚂蚁国各地。

给你蚂蚁国的N个点和M条边,现在问你至少要几笔才能所有边都画一遍.(一笔画的时候笔不离开纸) 
保证这M条边都不同且不会存在同一点的自环边. 
也就是蚂蚁分组遍历整个无向图,他们试图把所有的人分成几个小组,每个小组可以从不同的城镇开始。 
Tony想知道最少需要几组。 

Input输入包含多组测试用例,由多个空行分隔。 
每个测试用例的第一行是两个整数N(1<=N<=100000)、M(0<=M<=200000),表明蚂蚁国有N个城镇和M条道路。 
在M条线路之后,每条线路包含两个整数u,v,(1<=u,v<=N,表示有一条道路连接城镇u和城镇v。 
Output对于每个测试用例,输出需要形成的最少组数来实现它们的目标。Sample Input

3 3
1 2
2 3
1 3

4 2
1 2
3 4

Sample Output

1
2

解析:  题中没有保证所有的点都是一个连通块,所以对于每个连通块,都有三种情况 1、当前连通块每个点的度数都为偶数,即为欧拉回路  所以一笔就行 2、有 x 个奇点,已知每两个奇点可以组成一条欧拉路径,所以 笔画数 = x / 2;  3、 单个点成为连通块  那么0笔用并查集维护连通块就好了
#include <iostream>
#include <cstdio>
#include <sstream>
#include <cstring>
#include <map>
#include <cctype>
#include <set>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <bitset>
#define rap(i, a, n) for(int i=a; i<=n; i++)
#define rep(i, a, n) for(int i=a; i<n; i++)
#define lap(i, a, n) for(int i=n; i>=a; i--)
#define lep(i, a, n) for(int i=n; i>a; i--)
#define rd(a) scanf("%d", &a)
#define rlld(a) scanf("%lld", &a)
#define rc(a) scanf("%c", &a)
#define rs(a) scanf("%s", a)
#define pd(a) printf("%d\n", a);
#define plld(a) printf("%lld\n", a);
#define pc(a) printf("%c\n", a);
#define ps(a) printf("%s\n", a);
#define MOD 2018
#define LL long long
#define ULL unsigned long long
#define Pair pair<int, int>
#define mem(a, b) memset(a, b, sizeof(a))
#define _  ios_base::sync_with_stdio(0),cin.tie(0)
//freopen("1.txt", "r", stdin);
using namespace std;
const int maxn = 1e6 + 10, INF = 0x7fffffff, LL_INF = 0x7fffffffffffffff;
int deg[maxn], f[maxn], cnt[maxn];
set<int> g;
int find(int x)
{
    return f[x] == x ? x : (f[x] = find(f[x]));
}

int main()
{
    int n, m;
    while(cin >> n >> m)
    {
        for(int i = 1; i <= n; i++) f[i] = i;
        mem(deg, 0);
        mem(cnt, 0);
        g.clear();
        int u, v;
        for(int i = 1; i <= m; i++)
        {
            cin >> u >> v;
            int l = find(u);
            int r = find(v);
            if(l != r) f[l] = r;
            deg[u]++;
            deg[v]++;
        }
        for(int i = 1; i <= n; i++)
        {
            int x = find(i);
            if(deg[i] & 1) cnt[x]++;
            g.insert(x);
        }
        int res = 0;
        for(set<int>::iterator it = g.begin(); it != g.end(); it++)
        {
            int x = *it;
            if(deg[x] == 0) continue;
            if(cnt[x] == 0) res++;
            else res += cnt[x] / 2;
        }
        cout << res << endl;

    }

    return 0;
}


原文地址:https://www.cnblogs.com/WTSRUVF/p/9754583.html

时间: 2024-10-14 20:32:00

Ant Trip HDU - 3018(欧拉路的个数 + 并查集)的相关文章

HDU 3018 Ant Trip (欧拉路的个数 并查集)

Ant Trip Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 5501    Accepted Submission(s): 2146 Problem Description Ant Country consist of N towns.There are M roads connecting the towns. Ant Tony,

hdoj 3018 Ant Trip(无向图欧拉路||一笔画+并查集)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3018 思路分析:题目可以看做一笔画问题,求最少画多少笔可以把所有的边画一次并且只画一次: 首先可以求出该无向图中连通图的个数,在每个无向连通图中求出需要画的笔数再相加即为所求.在一个无向连通图中,如果所有的点的度数为偶数则存在一个欧拉回路, 则只需要画一笔即可:如果图中存在度数为奇数的点,则需要画的笔数为度数为奇数的点的个数 /2:需要注意的孤立的点不需要画: 代码如下: #include <cst

HDU 1232:畅通问题(并查集)

畅通工程 Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 29362    Accepted Submission(s): 15452 Problem Description 某省调查城镇交通状况,得到现有城镇道路统计表,表中列出了每条道路直接连通的城镇.省政府"畅通工程"的目标是使全省任何两个城镇间都可以实现交通(但不一定有

HDU 1988 Cube Stacking (数据结构-并查集)

Cube Stacking Time Limit: 2000MS   Memory Limit: 30000K Total Submissions: 18900   Accepted: 6568 Case Time Limit: 1000MS Description Farmer John and Betsy are playing a game with N (1 <= N <= 30,000)identical cubes labeled 1 through N. They start w

HDU 1325 Is It A Tree? 并查集

判断是否为树 森林不是树 空树也是树 成环不是树 数据: 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 1 0 0 1 2 2 3 4 5 0 0 2 5 0 0 ans: no no yes #include <stdio.h> #include <string.h> #include <stdlib.h> #include <limits.h> #include <malloc.h> #include <ctype

HDU 4879 ZCC loves march(并查集+set)

题意:一个最大10^18*10^18的矩阵,给你最多十万个士兵的位置,分别分布在矩阵里,可能会位置重复,然后有2种操作,一种是把第i个士兵向上下左右移动,另一种是把第i个士兵与他横坐标纵坐标相同的士兵全部移到这个点上,然后要计算花费. 这道题我想了好几天.在看了标程得到一些提示后总算写出来了.加了读入优化后快了100ms左右达到546ms. 做法:开2个set分别维护X相同的和Y相同的,但是会有相同位置点的坐标,该怎么办?用并查集去维护相同位置的点,读入的时候就可能会有位置相同的点,所以读的时候

HDU 2120 Ice_cream&#39;s world I(并查集)

题目地址:HDU 2120 这题虽然字数不多,但就是看不懂..意思是求最多有多少个被墙围起来的区域.显然就是求环的个数.然后用并查集求环个数就可以了. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #include <math.h> #include <ctype.h>

hdu 2818 Building Block(带权并查集)

题目: 链接:点击打开链接 题意: 有N个积木,1到N编号.进行一些操作P次,M:X Y把X积木放到Y的上面,如果X和Y相等请忽略.C:X 计算X积木下的积木数目. 思路: 带权并查集的题目,定义数组sum[i]表示i积木下面积木的数目.遇到操作M,就把X和Y合并到同一个集合中.我们视每个结点为1个 Pile,其中rank[i]就表示每个Pile处的积木的个数,Initially, there are N piles, and each pile contains one block.所以,ra

[ACM] POJ 2513 Colored Sticks (Trie树,欧拉通路,并查集)

Colored Sticks Time Limit: 5000MS   Memory Limit: 128000K Total Submissions: 29736   Accepted: 7843 Description You are given a bunch of wooden sticks. Each endpoint of each stick is colored with some color. Is it possible to align the sticks in a st